#!/usr/bin/bash

# This script replaces plugins with symlinks
# $1 : folder to replace with symlinks
# $2 : folder to search for replacements

set -e

pushd () {
    command pushd "$@" > /dev/null
}

popd () {
    command popd "$@" > /dev/null
}

function _sym {
	echo "linking $1 to $2"
	rm -rf $1
	ln -s $2 $1
}

JARS="
org.eclipse.core.commands_*.jar
org.eclipse.core.contenttype_*.jar
org.eclipse.core.databinding_*.jar
org.eclipse.core.databinding.beans_*.jar
org.eclipse.core.databinding.observable_*.jar
org.eclipse.core.databinding.property_*.jar
org.eclipse.core.expressions_*.jar
org.eclipse.core.filesystem_*.jar
org.eclipse.core.jobs_*.jar
org.eclipse.core.net_*.jar
org.eclipse.core.resources_*.jar
org.eclipse.core.runtime_*.jar
org.eclipse.e4.core.commands_*.jar
org.eclipse.e4.core.contexts_*.jar
org.eclipse.e4.core.di_*.jar
org.eclipse.e4.core.di.annotations_*.jar
org.eclipse.e4.core.di.extensions_*.jar
org.eclipse.e4.core.di.extensions.supplier_*.jar
org.eclipse.e4.core.services_*.jar
org.eclipse.e4.emf.xpath_*.jar
org.eclipse.e4.ui.bindings_*.jar
org.eclipse.e4.ui.css.core_*.jar
org.eclipse.e4.ui.css.swt_*.jar
org.eclipse.e4.ui.css.swt.theme_*.jar
org.eclipse.e4.ui.di_*.jar
org.eclipse.e4.ui.dialogs_*.jar
org.eclipse.e4.ui.model.workbench_*.jar
org.eclipse.e4.ui.services_*.jar
org.eclipse.e4.ui.swt.gtk_*.jar
org.eclipse.e4.ui.widgets_*.jar
org.eclipse.e4.ui.workbench_*.jar
org.eclipse.e4.ui.workbench3_*.jar
org.eclipse.e4.ui.workbench.addons.swt_*.jar
org.eclipse.e4.ui.workbench.renderers.swt_*.jar
org.eclipse.e4.ui.workbench.swt_*.jar
org.eclipse.ecf_*.jar
org.eclipse.ecf.filetransfer_*.jar
org.eclipse.ecf.identity_*.jar
org.eclipse.ecf.provider.filetransfer_*.jar
org.eclipse.ecf.provider.filetransfer.httpclient4_*.jar
org.eclipse.ecf.provider.filetransfer.httpclient4.ssl_*.jar
org.eclipse.ecf.provider.filetransfer.ssl_*.jar
org.eclipse.ecf.ssl_*.jar
org.eclipse.emf.common_*.jar
org.eclipse.emf.ecore_*.jar
org.eclipse.emf.ecore.change_*.jar
org.eclipse.emf.ecore.xmi_*.jar
org.eclipse.equinox.app_*.jar
org.eclipse.equinox.bidi_*.jar
org.eclipse.equinox.common_*.jar
org.eclipse.equinox.concurrent_*.jar
org.eclipse.equinox.console_*.jar
org.eclipse.equinox.ds_*.jar
org.eclipse.equinox.event_*.jar
org.eclipse.equinox.frameworkadmin_*.jar
org.eclipse.equinox.frameworkadmin.equinox_*.jar
org.eclipse.equinox.http.jetty_*.jar
org.eclipse.equinox.http.registry_*.jar
org.eclipse.equinox.jsp.jasper_*.jar
org.eclipse.equinox.jsp.jasper.registry_*.jar
org.eclipse.equinox.p2.artifact.repository_*.jar
org.eclipse.equinox.p2.console_*.jar
org.eclipse.equinox.p2.core_*.jar
org.eclipse.equinox.p2.director_*.jar
org.eclipse.equinox.p2.director.app_*.jar
org.eclipse.equinox.p2.directorywatcher_*.jar
org.eclipse.equinox.p2.engine_*.jar
org.eclipse.equinox.p2.extensionlocation_*.jar
org.eclipse.equinox.p2.garbagecollector_*.jar
org.eclipse.equinox.p2.jarprocessor_*.jar
org.eclipse.equinox.p2.metadata_*.jar
org.eclipse.equinox.p2.metadata.repository_*.jar
org.eclipse.equinox.p2.operations_*.jar
org.eclipse.equinox.p2.publisher_*.jar
org.eclipse.equinox.p2.publisher.eclipse_*.jar
org.eclipse.equinox.p2.reconciler.dropins_*.jar
org.eclipse.equinox.p2.repository_*.jar
org.eclipse.equinox.p2.touchpoint.eclipse_*.jar
org.eclipse.equinox.p2.touchpoint.natives_*.jar
org.eclipse.equinox.p2.transport.ecf_*.jar
org.eclipse.equinox.p2.ui_*.jar
org.eclipse.equinox.p2.ui.sdk_*.jar
org.eclipse.equinox.p2.ui.sdk.scheduler_*.jar
org.eclipse.equinox.p2.updatechecker_*.jar
org.eclipse.equinox.preferences_*.jar
org.eclipse.equinox.registry_*.jar
org.eclipse.equinox.security_*.jar
org.eclipse.equinox.security.ui_*.jar
org.eclipse.equinox.simpleconfigurator_*.jar
org.eclipse.equinox.simpleconfigurator.manipulator_*.jar
org.eclipse.equinox.util_*.jar
org.eclipse.help_*.jar
org.eclipse.help.base_*.jar
org.eclipse.help.ui_*.jar
org.eclipse.help.webapp_*.jar
org.eclipse.jface_*.jar
org.eclipse.jface.databinding_*.jar
org.eclipse.jface.text_*.jar
org.eclipse.rcp_*.jar
org.eclipse.swt_*.jar
org.eclipse.text_*.jar
org.eclipse.ui_*.jar
org.eclipse.ui.forms_*.jar
org.eclipse.ui.intro_*.jar
org.eclipse.ui.net_*.jar
org.eclipse.ui.views_*.jar
org.eclipse.ui.workbench_*.jar
org.eclipse.update.configurator_*.jar
org.eclipse.equinox.security.linux.*
org.eclipse.swt.gtk.linux.*
"

for name in ${JARS}; do
	echo "BEGIN: $name"
	pushd $1
		for one in $name; do
			pushd $2
				declare -i FOUND=0
				for two in $name; do
					FOUND=$((FOUND + 1))
					echo "$one match $two"
					if [ $FOUND -gt 1 ]
					then
						echo "Found more than one match for $one, exiting"
						rm -rf $1
						rm -rf $2
						exit 1
					fi
					_sym $1/$one $2/$two
				done
			popd
		done
	popd
done
